/**
/** Comparative Genomics workflow
/**
/** This workflow find the duplicate genes from a proteome
/** Then, It finds the Tandemly Arrayed Genes (TAGs)
/**/
include { GUNZIP as GUNZIP_1 } from "./modules/gunzip.nf"
include { GUNZIP as GUNZIP_2 } from "./modules/gunzip.nf"
// include { BLAST_ALL_AGAINST_ALL } from "./modules/blast.nf"
include { FILTER_FASTA } from "./modules/filter_fasta.nf"
include { FILTER_BLASTP } from "./modules/filter_blastp.nf"
include { CLUSTERING } from "./modules/clustering.nf"
include { TAGs } from "./modules/tags.nf"

workflow {
    proteome = Channel.fromPath(params.proteome)
    gff3 = Channel.fromPath(params.gff3)
    GUNZIP_1(proteome)
    GUNZIP_2(gff3)
    FILTER_FASTA(GUNZIP_1.out)
//    BLAST_ALL_AGAINST_ALL(FILTER_FASTA.out.proteome)
//    FILTER_BLASTP(params.min_coverage, params.min_identity, BLAST_ALL_AGAINST_ALL.out, GUNZIP_1.out, FILTER_FASTA.out.lengths)

 //   CLUSTERING(FILTER_BLASTP.out)

  //  TAGs(CLUSTERING.out, GUNZIP_2.out)
}
